int fingerPins[5]={A0, A1, A2, A3, A4};
int fingerVals[5];
const char *names[5]={"Thumb: ", "Index: ", "Middle: ", "Ring: ", "Pinky: "};
int CalibrationVals[2][5];

void setup() {
  Serial.begin(9600);
  CalibrateFlexSensors();
}

void loop() {
}

void CalibrateFlexSensors(){
  int calibrationCount=0;
  while(calibrationCount<=1){
     if(calibrationCount==0){
      Serial.println("Please lay your hand flat");
      delay(3000);
      Serial.println("Collecting minimum flex readings");
     }
     else if(calibrationCount==1){
      Serial.println("Please close you hand into a fist");
      delay(3000);
      Serial.println("Collecting maximum flex readings");
     }
     for(int i=0; i<5; i++){
      int readingCount=0;
      int readingSum=0;
      while(readingCount<10){
        readingSum+=analogRead(fingerPins[i]);
        readingCount+=1;
        delay(200);
      }      
      CalibrationVals[calibrationCount][i]=readingSum/10;
     }
     calibrationCount+=1;
  }
  Serial.println("Calibration Complete");
  Serial.println("In the order from thumb to pinky, your offsets are:");
  for(int i=0; i<2; i++){
    if(i==0){Serial.print("Minimum Offsets:\t");}
    else{Serial.print("Maximum Offsets:\t");}
    for(int j=0; j<5; j++){
      Serial.print(CalibrationVals[i][j]);
      Serial.print(", ");
    }  
    Serial.println();
  }
}

