#include <SoftwareSerial.h>
#include <Servo.h>
#include <stdint.h>

SoftwareSerial mySerial(10, 11);

Servo thumb, index, middle, ring, pinky;
Servo fingers[5] = {thumb, index, middle, ring, pinky};

int servoPins[5] = {2, 3, 4, 5, 6};
int bent[5] = {0, 0, 0, 0, 0};
int initAngles[5] = {90, 55, 55, 90, 90};
int angles[5] = {180, 180, 180, 90, 90};

int flexSensorMidPoints[5] = {900, 550, 550, 500, 500};

int flexSensorValue;
int handPin;
int read;

void setup() {
  thumb.attach(2);
  index.attach(3);
  middle.attach(4);
  ring.attach(5);
  pinky.attach(6);

  for (int i = 0; i < 5; i++) {
    fingers[i].write(initAngles[i]);
  }

  Serial.begin(9600);
  mySerial.begin(38400);

  delay(1000);
}

void loop() {
  read = 0;
  if (mySerial.available() >= 3) {
    read = 1;
    handPin = mySerial.read();
    uint8_t highByte = mySerial.read();
    uint8_t lowByte = mySerial.read();
    flexSensorValue = (highByte << 8) | lowByte;
    Serial.print("From ");
    Serial.print(handPin);
    Serial.print(": ");
    Serial.println(flexSensorValue);
  }


  if (read == 1) {
    if (flexSensorValue > flexSensorMidPoints[handPin] && bent[handPin] == 0) {
      Serial.print("Bent from ");
      Serial.print(handPin);
      Serial.print(": ");
      Serial.println(flexSensorValue);
      Serial.println("-------------------------");
      fingers[handPin].write(angles[handPin]);
      bent[handPin] = 1;
    } else if (flexSensorValue <= flexSensorMidPoints[handPin] && bent[handPin] == 1) {
      Serial.print("Release from ");
      Serial.print(handPin);
      Serial.print(": ");
      Serial.println(flexSensorValue);
      Serial.println("-------------------------");
      bent[handPin] = 0;
      fingers[handPin].write(initAngles[handPin]);
    }

  }
}
